% Laboratrio de Instrumentao para Biomecnica-DEM-FEF-UNICAMP
% Funo:constroiCalibrado
% Programador:	Ricardo M. L. Barros
% ltima modificao: 10.2004
% Declarao: [p]=constroiCalibrador(p1,p2,vecD)
% p1=[0 0]; p2=[d12 0];  vetD=[d13 d23;d14 d24;d15 d25;d16 d26]; sempre a distancia ao p1 na coluna 1 e ate p2 na coluna 2
%           [p]=constroiCalibrador(p1,p2,vecD)
% Descrio: Calcula as coordenadas dos pontos a partir das distancias de
% cada um ate p1 e p2
% O sistema de coordenadas tem origem em p1, direcao x de 1 para 2 e eh
% ortonormal

% function [p,calib]=constroiCalibrador(p1,p2,matDist)
function [p,calib]=constroiCalibrador(p1,p2,matDist,coordZ)
coordZ = coordZ';

d12 = norm(p2 - p1);
p(1,:) = p1; p(2,:) = p2;
for i=1:size(matDist,1);
    d1i(i) = matDist(i,1); %Dist do ponto i ate 1
    d2i(i) = matDist(i,2); %Dist do ponto i ate 2
    [d] = triang(d12,d1i(i),d2i(i));
    p(i+2,1) = d(1);
    p(i+2,2) = d(2);
end

[nlin,ncol] = size(p);
[nlin2,ncol2] = size(coordZ);
calib = [];
for i=1:nlin
    calib = [calib; [repmat(p(i,:),nlin2,1) coordZ]];
end

[nlin3,ncol3] = size(calib);
calib = [(1:nlin3)' calib];

function [d] = triang(d12,d13,d23)
m = (d13^2 + d12^2 - d23^2) / (2 * d12);
n = d12 - m;

if ((d23^2 - n^2) < 0.001) h = 0;
else
    h = sqrt(d23^2 - n^2);
    if (d23 < 0) h = h * -1; end
end

d(1) = m;
d(2) = h;
